<?php
/*
Plugin Name: Confirm User Registration
Plugin URI: http://confirm-user-registration.horttcore.de/
Description: Admins have to confirm a user registration, a notification will be send when the account gets activated
Author: Ralf Hortt
Version: 1.1.1
Author URI: http://horttcore.de/
*/


add_action('wp_authenticate','cur_authenticate');
add_action('admin_menu', 'cur_submenu');


//======================================
// Description: Mangement page, to de/activate users
Function cur_management(){
global $wpdb;

	if ($_GET['activate']) {
		update_usermeta($_GET['activate'], 'authentication', '1'); #activate
		cur_authentication_mail($_GET['activate']);
	}
	elseif ($_GET['deactivate']) {
		update_usermeta($_GET['deactivate'], 'authentication', '0'); #deactivate
	}
	
	// Get all users
	$sql = "SELECT ID FROM $wpdb->users WHERE ID != '1'";
	$all_user = $wpdb->get_col($sql);
	
	// Get all authed users
	$sql = "SELECT user_id FROM $wpdb->usermeta WHERE meta_key = 'authentication' AND meta_value = '1'";
	$all_auth = $wpdb->get_col($sql);
	?>
	<style type="text/css">
		.wrap a {
			display: block;
			border: 0px;
			padding: 5px;
		}
				
		.wrap a:hover {
			background: #ccc;
			color: #000;
		}
		
		.wrap .alt {
			background: #f1f1f1;
		}
	
	</style>
	<div class="wrap">
		<h2>User in waiting queue</h2>
		<p>
		<?php
		
		$i = 0;
	
		foreach($all_user as $user) {
			if ($i % 2 == 0) {$class = 'alt';} else {unset($class);}
			if (!in_array($user,$all_auth)) {
				echo "<a class='$class' href='?page=confirm-user-registration.php&activate=$user'>".get_usermeta($user, 'nickname')."</a>\n";
				$i++;
			}
		}
		
		if ($i == 0) {
			echo "No user in waiting list";
		}
		
		?>
		</p>
		<h2 style="margin: 25px 0 0 0">Active User</h2>
		<p>
		<?php
		
		$i = 0;

		foreach($all_auth as $user) {
			if ($user != 1) { # exclude admin
				if ($i%2 == 0) {$class = 'alt';} else {unset($class);} # setting different styles
				echo "<a class='$class' href='?page=confirm-user-registration.php&deactivate=$user'>".get_usermeta($user, 'nickname')."</a>\n"; # link to deactivate the user
				$i++;
			}
		}
		
		if ($i == 0) {
			echo "No user to activate!";
		}
		?>
		</p>
	</div>
	<?php
}

//======================================
// Description: Checks if the user is authenticated
Function cur_authenticate(){
	global $user_login, $errors;
	if ($user_login && !empty($_POST)) {
		
		$userid  = get_useridbylogin($user_login);
				
		if (!is_authenticated($userid) && isset($userid)) {
			array_push($errors,'Fehler: Ihr Account wurde noch nicht zugelassen.');
		}
	}
}

//======================================
// Description:
// Require: User login name
Function get_useridbylogin($user_login){
global $wpdb;
	
	$sql = "SELECT ID FROM $wpdb->users WHERE user_login = '$user_login'";
	$userid = $wpdb->get_var($sql);
	
	return $userid;
}

//======================================
// Description: Conditional function if user is athenticated
// Require: valid user_ID
Function is_authenticated($userid){
	$auth = get_usermeta($userid,'authentication');
	
	if ($userid == 1) {
		return true;
	}
	elseif ($auth == 1) {
		return true;
	}
	else {
		return false;
	}
}

//======================================
// Description:
// Require:
// Param:
Function cur_authentication_mail($user_id){
global $wpdb;
	$sql = "SELECT user_email FROM $wpdb->users WHERE ID = '$user_id'";
	$to = $wpdb->get_var($sql);
	$subject = "Account Confirmation";
	$message = "You account has been approved by an administrator!\n";
	$message.= "Login @ ".get_bloginfo('url')."wp-login.php\n";
	$message.= "\n";
	$message.= "This message is auto generated\n";
	
	if (!mail($to, $subject, $message)) {
		echo "Message failed";
	}
	
}


//======================================
// Description: Adding submenu entry
Function cur_submenu(){
	add_submenu_page('users.php','Activate User Accounts', 'Activate User Accounts', '10', __FILE__, 'cur_management');
}



?>